#include<stdio.h>

  /* Za cijeli broj n kazemo da je strogo padajuci, ako su dekadske
     znamenke broja |n| strogo padajuce, gledano od najnize prema
     najvisoj.
     Napisite program koji ucitava cijele brojeve n, sve dok se
     ne ucita broj koji nije strogo padajuci.
     Ukoliko je n strogo padajuci, program treba ispisati poruku
     "Broj je strogo padajuci", sumu svih znamenaka broja |n| i
     najmanju znamenku broja $|n|$. U protivnom, program treba ispisati
     poruku "Broj nije strogo padajuci".
     Smatramo da broj n = 0 ima jednu znamenku (jednaku 0).

     Primjer: Brojevi n = 269, n = -269 i n = 0 su strogo padajuci,
     a brojevi n = 20, n = -20 i n = 11 nisu strogo padajuci.
  */

int main(void) {

    int monoton = 1, n, pom_n, znam, preth_znam,
        suma_znam, min_znam;

        /* Petlja za obradu niza brojeva. */

    while (1) {  // Moze i  do { ... } while (monoton);

        printf("Upisite cijeli broj:\n");
        scanf("%d", &n);

            /* Apsolutna vrijednost |n|. */
        if (n < 0) n = -n;

            /* Pomocni n za provjeru monotonosti znamenki. */
        pom_n = n;

            /* Prva (najniza) znamenka. */
        preth_znam = pom_n % 10;
        pom_n /= 10;

            /* Petlja za provjeru trazene monotonosti za parove
               susjednih znamenki - prethodne i trenutne.
               Jednoznamenkasti n i n = 0 su monotoni (po def.).
               Petlja se tada NE izvrsava, a monoton ostaje na 1. */

        while (pom_n > 0) {
            znam = pom_n % 10;
            if (znam >= preth_znam) {  // Pogresan poredak.
                monoton = 0;
                break;
            }
            preth_znam = znam;  // Pomak trenutne u prethodnu.
            pom_n /= 10;
        }

            /* Nastavak posla, ovisno o tome je li broj n
               monoton ili ne. Dalje radimo s n, bez pomocnog. */

        if (monoton) {  // Broj n je monoton. Nadji ostalo sto treba.

            suma_znam = 0;
            min_znam = 10;  // Lazna inicijalizacija.

                /* Po dogovoru, n = 0 ima jednu znamenku jednaku 0.
                   Zato do-while, a NE while petlja! */
            do {
                znam = n % 10;
                suma_znam += znam;
                if (znam < min_znam) min_znam = znam;
                n /= 10;
            } while (n > 0);

/* Napomena: Znamo da je broj strogo padajuci.
     Onda je najmanja znamenka = NAJVISA! Potrebne promjene su:
     Obrisati inicijalizaciju min_znam.
     U do-while petlji, if treba biti:
                if (n < 10) min_znam = znam;
*/

            printf("Broj je strogo padajuci\n");
            printf("Suma znamenaka je %d\n", suma_znam);
            printf("Najmanja znamenka je %d\n", min_znam);
        }
        else {  // Broj n nije monoton. Poruka i prekid petlje.
            printf("Broj nije strogo padajuci");
            break;  // Kraj niza.
        }
    }

    return 0;
}
