#include<stdio.h>

  /* Za cijeli broj n kazemo da je strogo rastuci, ako su dekadske
     znamenke broja |n| strogo rastuce, gledano od najnize prema
     najvisoj.
     Napisite program koji ucitava cijele brojeve n, sve dok se
     ne ucita broj koji nije strogo rastuci.
     Ukoliko je n strogo rastuci, program treba ispisati poruku
     "Broj je strogo rastuci", produkt svih znamenaka broja |n| i
     najmanju znamenku broja $|n|$. U protivnom, program treba ispisati
     poruku "Broj nije strogo rastuci".
     Smatramo da broj n = 0 ima jednu znamenku (jednaku 0).

     Primjer: Brojevi n = 962, n = -962 i n = 0 su strogo rastuci,
     a brojevi n = 13, n = -13 i n = 22 nisu strogo rastuci.
  */

int main(void) {

    int monoton = 1, n, pom_n, znam, preth_znam,
        prod_znam, min_znam;

        /* Petlja za obradu niza brojeva. */

    while (1) {  // Moze i  do { ... } while (monoton);

        printf("Upisite cijeli broj:\n");
        scanf("%d", &n);

            /* Apsolutna vrijednost |n|. */
        if (n < 0) n = -n;

            /* Pomocni n za provjeru monotonosti znamenki. */
        pom_n = n;

            /* Prva (najniza) znamenka. */
        preth_znam = pom_n % 10;
        pom_n /= 10;

            /* Petlja za provjeru trazene monotonosti za parove
               susjednih znamenki - prethodne i trenutne.
               Jednoznamenkasti n i n = 0 su monotoni (po def.).
               Petlja se tada NE izvrsava, a monoton ostaje na 1. */

        while (pom_n > 0) {
            znam = pom_n % 10;
            if (znam <= preth_znam) {  // Pogresan poredak.
                monoton = 0;
                break;
            }
            preth_znam = znam;  // Pomak trenutne u prethodnu.
            pom_n /= 10;
        }

            /* Nastavak posla, ovisno o tome je li broj n
               monoton ili ne. Dalje radimo s n, bez pomocnog. */

        if (monoton) {  // Broj n je monoton. Nadji ostalo sto treba.

            prod_znam = 1;
            min_znam = 10;  // Lazna inicijalizacija.

                /* Po dogovoru, n = 0 ima jednu znamenku jednaku 0.
                   Zato do-while, a NE while petlja! */
            do {
                znam = n % 10;
                prod_znam *= znam;
                if (znam < min_znam) min_znam = znam;
                n /= 10;
            } while (n > 0);

/* Napomena: Znamo da je broj strogo rastuci.
     Onda je najmanja znamenka = NAJNIZA! Potrebne promjene su:
     Inicijalizacija:
            min_znam = n % 10;
     Obrisati if u do-while petlji.
*/

            printf("Broj je strogo rastuci\n");
            printf("Produkt znamenaka je %d\n", prod_znam);
            printf("Najmanja znamenka je %d\n", min_znam);
        }
        else {  // Broj n nije monoton. Poruka i prekid petlje.
            printf("Broj nije strogo rastuci");
            break;  // Kraj niza.
        }
    }

    return 0;
}
